%define boost_version 1.29.0
%define jam_version 3.1.2
%define regex_version 3.31
%define python_version %boost_version
%define thread_version %boost_version
%define signals_version %boost_version

Name: boost
Version: %boost_version
Release: alt1

Summary: Boost libraries
License: free for use and distribute
Group: Development/C++
Url: http://www.boost.org

Packager: Alexey Voinov <voins@altlinux.ru>

Source: %name-%version.tar.bz2
Source1: regex-config.in
Source2: python-config.in
Source3: thread-config.in
Source4: signals-config.in


%description
The Boost web site provides free peer-reviewed portable C++ source libraries. The emphasis is on
libraries which work well with the C++ Standard Library. One goal is to establish "existing practice"
and provide reference implementations so that the Boost libraries are suitable for eventual
standardization. Some of the libraries have already been proposed for inclusion in the C++ Standards
Committee's upcoming C++ Standard Library Technical Report.
                          
Although Boost was begun by members of the C++ Standards Committee Library Working Group, membership
has expanded to include nearly two thousand members of the C++ community at large.

%package devel
Summary: Boost libraries
Group: Development/C++
License: free for use and distribute

%description devel
The Boost web site provides free peer-reviewed portable C++ source libraries. The emphasis is on
libraries which work well with the C++ Standard Library. One goal is to establish "existing practice"
and provide reference implementations so that the Boost libraries are suitable for eventual
standardization. Some of the libraries have already been proposed for inclusion in the C++ Standards
Committee's upcoming C++ Standard Library Technical Report.
                          
Although Boost was begun by members of the C++ Standards Committee Library Working Group, membership
has expanded to include nearly two thousand members of the C++ community at large.


%package jam
Version: %jam_version
License: GPL
Summary: Boost Jam is a replacement for make
Group: Development/Other

%description jam
Boost Jam is a build tool based on FTJam, which in turn is based on
Perforce Jam. It contains significant improvements made to facilitate
its use in the Boost Build System, but should be backward compatible
with Perforce Jam.




%package regex
Version: %regex_version
License: BSD
Summary: Regular expressions library for C++
Group: Development/C++
Obsoletes: boost-regex-gcc2, boost-regex-gcc3
Provides: boost-regex-gcc2 = %regex_version-%release, boost-regex-gcc3 = %regex_version-%release


%description regex
Regular expressions are a form of pattern-matching that are often used 
in text processing; many users will be familiar with the Unix utilities 
grep, sed and awk, and the programming language perl, each of which make 
extensive use of regular expressions. Traditionally C++ users have been 
limited to the POSIX C API's for manipulating regular expressions, and 
while regex++ does provide these API's, they do not represent the best 
way to use the library. For example regex++ can cope with wide character 
strings, or search and replace operations (in a manner analogous to 
either sed or perl), something that traditional C libraries can not do.

%package regex-devel
Version: %regex_version
License: BSD
Summary: Regular expressions library for C++. Development files.
Group: Development/C++
Obsoletes: boost-regex-gcc2-devel, boost-regex-gcc3-devel, boost-regex-common-devel
Provides: boost-regex-gcc2-devel = %regex_version-%release, boost-regex-gcc3-devel = %regex_version-%release
Provides: boost-regex-common-devel = %regex_version-%release
Requires: boost-regex = %regex_version-%release, boost-devel = %boost_version-%release

%description regex-devel
Regular expressions are a form of pattern-matching that are often used 
in text processing; many users will be familiar with the Unix utilities 
grep, sed and awk, and the programming language perl, each of which make 
extensive use of regular expressions. Traditionally C++ users have been 
limited to the POSIX C API's for manipulating regular expressions, and 
while regex++ does provide these API's, they do not represent the best 
way to use the library. For example regex++ can cope with wide character 
strings, or search and replace operations (in a manner analogous to 
either sed or perl), something that traditional C libraries can not do.

%package regex-devel-static
Version: %regex_version
License: BSD
Summary: Regular expressions library for C++
Group: Development/C++
Requires: boost-regex-devel = %regex_version-%release

%description regex-devel-static
Regular expressions are a form of pattern-matching that are often used 
in text processing; many users will be familiar with the Unix utilities 
grep, sed and awk, and the programming language perl, each of which make 
extensive use of regular expressions. Traditionally C++ users have been 
limited to the POSIX C API's for manipulating regular expressions, and 
while regex++ does provide these API's, they do not represent the best 
way to use the library. For example regex++ can cope with wide character 
strings, or search and replace operations (in a manner analogous to 
either sed or perl), something that traditional C libraries can not do.




%package python
Version: %python_version
Group: Development/C++
Summary: The Boost Python Library (Boost.Python)
Obsoletes: boost-python-gcc2, boost-python-gcc3
Provides: boost-python-gcc2 = %python_version-%release, boost-python-gcc3 = %python_version-%release

%description python
Use the Boost Python Library to quickly and easily export a C++ library to
Python such that the Python interface is very similar to the C++ interface. It
is designed to be minimally intrusive on your C++ design. In most cases, you
should not have to alter your C++ classes in any way in order to use them with
Boost.Python. The system should simply ``reflect'' your C++ classes and
functions into Python.

%package python-devel
Version: %python_version
Group: Development/C++
Summary: The Boost Python Library (Boost.Python)
Obsoletes: boost-python-gcc2-devel, boost-python-gcc3-devel, boost-python-common-devel
Provides: boost-python-gcc2-devel = %python_version-%release, boost-python-gcc3-devel = %python_version-%release
Provides: boost-python-common-devel = %python_version-%release
Requires: boost-python = %python_version-%release, boost-devel = %boost_version-%release

%description python-devel
Use the Boost Python Library to quickly and easily export a C++ library to
Python such that the Python interface is very similar to the C++ interface. It
is designed to be minimally intrusive on your C++ design. In most cases, you
should not have to alter your C++ classes in any way in order to use them with
Boost.Python. The system should simply ``reflect'' your C++ classes and
functions into Python.

%package python-devel-static
Version: %python_version
Group: Development/C++
Summary: The Boost Python Library (Boost.Python)
Requires: boost-python-devel = %python_version-%release

%description python-devel-static
Use the Boost Python Library to quickly and easily export a C++ library to
Python such that the Python interface is very similar to the C++ interface. It
is designed to be minimally intrusive on your C++ design. In most cases, you
should not have to alter your C++ classes in any way in order to use them with
Boost.Python. The system should simply ``reflect'' your C++ classes and
functions into Python.





%package thread
Version: %thread_version
Group: Development/C++
Summary: The Boost Threads Library (Boost.Threads)
Obsoletes: boost-thread-gcc2, boost-thread-gcc3
Provides: boost-thread-gcc2 = %thread_version-%release, boost-thread-gcc3 = %thread_version-%release

%description thread
Boost.Threads allows C++ programs to execute as multiple, asynchronous,
independent, threads-of-execution. Each thread has its own machine state
including program instruction counter and registers. Programs which execute
as multiple threads are called multi-threaded programs to distinguish them
from traditional single-threaded programs. Definitions gives a more complete
description of the multi-threading execution environment.

%package thread-devel
Version: %thread_version
Group: Development/C++
Summary: The Boost Threads Library (Boost.Threads)
Obsoletes: boost-thread-gcc2-devel, boost-thread-gcc3-devel, boost-thread-common-devel
Provides: boost-thread-gcc2-devel = %thread_version-%release, boost-thread-gcc3-devel = %thread_version-%release
Provides: boost-thread-common-devel = %thread_version-%release
Requires: boost-thread = %thread_version-%release, boost-devel = %boost_version-%release

%description thread-devel
Boost.Threads allows C++ programs to execute as multiple, asynchronous,
independent, threads-of-execution. Each thread has its own machine state
including program instruction counter and registers. Programs which execute
as multiple threads are called multi-threaded programs to distinguish them
from traditional single-threaded programs. Definitions gives a more complete
description of the multi-threading execution environment.
		     
%package thread-devel-static
Version: %thread_version
Group: Development/C++
Summary: The Boost Threads Library (Boost.Threads)
Requires: boost-thread-devel = %thread_version-%release

%description thread-devel-static
Boost.Threads allows C++ programs to execute as multiple, asynchronous,
independent, threads-of-execution. Each thread has its own machine state
including program instruction counter and registers. Programs which execute
as multiple threads are called multi-threaded programs to distinguish them
from traditional single-threaded programs. Definitions gives a more complete
description of the multi-threading execution environment.





%package signals
Version: %signals_version
Group: Development/C++
Summary: The Boost Signals Library (Boost.Signals)

%description signals

%package signals-devel
Version: %signals_version
Group: Development/C++
Summary: The Boost Signals Library (Boost.Signals)
Requires: boost-signals = %signals_version-%release, boost-devel = %boost_version-%release

%description signals-devel
		     
%package signals-devel-static
Version: %signals_version
Group: Development/C++
Summary: The Boost Signals Library (Boost.Signals)
Requires: boost-signals-devel = %signals_version-%release

%description signals-devel-static





%prep 
%setup -q -n %{name}_1_29_0 
chmod u+w -R *

%build
cd tools/build/jam_src
make
cd -
tools/build/jam_src/bin.linuxx86/bjam -sPYTHON_ROOT=%_prefix

cd libs/thread/src
rm -f *.o
g++ -c -I../../../ %optflags *.cpp
g++ -shared %optflags -o libboost_thread.so.%version -Wl,--soname=libboost_thread.so
ar cqs libboost_thread.a *.o
cd -


%install
mkdir -p $RPM_BUILD_ROOT%_bindir
mkdir -p $RPM_BUILD_ROOT%_includedir
mkdir -p $RPM_BUILD_ROOT%_libdir

cp -R boost $RPM_BUILD_ROOT%_includedir

install -m 755 tools/build/jam_src/bin.linuxx86/jam $RPM_BUILD_ROOT%_bindir
install -m755 libs/regex/build/bin-stage/libboost_regex*.so.* $RPM_BUILD_ROOT%_libdir
ln -s libboost_regex.so.%boost_version \
	$RPM_BUILD_ROOT%_libdir/libboost_regex.so
ln -s libboost_regex_debug.so.%boost_version \
	$RPM_BUILD_ROOT%_libdir/libboost_regex_debug.so
install -m644 libs/regex/build/bin-stage/libboost_regex*.a $RPM_BUILD_ROOT%_libdir
install -m755 %SOURCE1 $RPM_BUILD_ROOT/%_bindir/boost-regex-config

install -m755 libs/python/build/bin-stage/libboost_python*.so.* $RPM_BUILD_ROOT%_libdir
ln -s libboost_python.so.%boost_version \
	$RPM_BUILD_ROOT%_libdir/libboost_python.so
ln -s libboost_python_debug.so.%boost_version \
	$RPM_BUILD_ROOT%_libdir/libboost_python_debug.so
#install -m644 libs/python/build/bin-stage/libboost_python*.a $RPM_BUILD_ROOT%_libdir
install -m755 %SOURCE2 $RPM_BUILD_ROOT/%_bindir/boost-python-config

install -m755 libs/thread/src/libboost_thread*.so.* $RPM_BUILD_ROOT%_libdir
install -m644 libs/thread/src/libboost_thread*.a $RPM_BUILD_ROOT%_libdir
install %SOURCE3 $RPM_BUILD_ROOT/%_bindir/boost-thread-config
ln -s libboost_thread.so.%boost_version \
	$RPM_BUILD_ROOT%_libdir/libboost_thread.so

install -m755 libs/signals/build/bin/libboost_signals.a/gcc/release/*/*.a $RPM_BUILD_ROOT%_libdir
install -m755 libs/signals/build/bin/libboost_signals.so/gcc/release/*/*/*.so $RPM_BUILD_ROOT%_libdir
install %SOURCE4 $RPM_BUILD_ROOT/%_bindir/boost-signals-config
mv $RPM_BUILD_ROOT%_libdir/libboost_signals.so $RPM_BUILD_ROOT%_libdir/libboost_signals.so.%version
ln -s libboost_signals.so.%boost_version \
	$RPM_BUILD_ROOT%_libdir/libboost_signals.so

#install docs
docdir=$RPM_BUILD_ROOT%_docdir/%name-%version
mkdir -p $docdir
mkdir -p $docdir/libs
mkdir -p $docdir/libs/python
mkdir -p $docdir/libs/regex
mkdir -p $docdir/libs/signals
mkdir -p $docdir/libs/thread
cp README boost.css *.gif index.htm $docdir
cp libs/*.htm libs/*.html $docdir/libs
cp -r status people more $docdir
cp -r libs/{a,b,c,d,f,g,i,l,m,n,po,pr,ra,sm,st,te,ti,to,tu,ty,u}*/ $docdir/libs
cp -r libs/python/{doc,example,index.html}* $docdir/libs/python
cp -r libs/regex/example libs/regex/*.{htm,txt} $docdir/libs/regex
cp -r libs/signals/{doc,example,index.html}* $docdir/libs/signals
cp -r libs/thread/{doc,example,tutorial,index.html}* $docdir/libs/thread
ln -s ../../../include/boost $docdir/boost


%files devel
%dir %_includedir/boost
%dir %_includedir/boost/bind
%dir %_includedir/boost/compatibility
%dir %_includedir/boost/compatibility/cpp_c_headers
%dir %_includedir/boost/config/
%dir %_includedir/boost/detail
%dir %_includedir/boost/date_time
%dir %_includedir/boost/function
%dir %_includedir/boost/format
%dir %_includedir/boost/graph
%dir %_includedir/boost/integer
%dir %_includedir/boost/io
%dir %_includedir/boost/lambda
%dir %_includedir/boost/math
%dir %_includedir/boost/mpl
%dir %_includedir/boost/multi_array
%dir %_includedir/boost/numeric
%dir %_includedir/boost/pending
%dir %_includedir/boost/pool
%dir %_includedir/boost/preprocessor
%dir %_includedir/boost/random
%dir %_includedir/boost/test
%dir %_includedir/boost/tuple
%dir %_includedir/boost/type_traits
%dir %_includedir/boost/utility
%_includedir/boost/[abdfghilmnopstuvw]*.hpp
%_includedir/boost/call_traits.hpp
%_includedir/boost/cast.hpp
%_includedir/boost/checked_delete.hpp
%_includedir/boost/compose.hpp
%_includedir/boost/compressed_pair.hpp
%_includedir/boost/concept_archetype.hpp
%_includedir/boost/concept_check.hpp
%_includedir/boost/config.hpp
%_includedir/boost/counting_iterator.hpp
%_includedir/boost/crc.hpp
%_includedir/boost/cstdint.hpp
%_includedir/boost/cstdlib.hpp
%_includedir/boost/current_function.hpp
%_includedir/boost/random.hpp
%_includedir/boost/rational.hpp
%_includedir/boost/ref.hpp
%_includedir/boost/bind/*
%_includedir/boost/compatibility/cpp_c_headers/*
%_includedir/boost/config/*
%_includedir/boost/detail/*
%_includedir/boost/date_time/*
%_includedir/boost/function/*
%_includedir/boost/format/*
%_includedir/boost/graph/*
%_includedir/boost/integer/*
%_includedir/boost/io/*
%_includedir/boost/lambda/*
%_includedir/boost/math/*
%_includedir/boost/mpl/*
%_includedir/boost/multi_array/*
%_includedir/boost/numeric/*
%_includedir/boost/pending/*
%_includedir/boost/pool/*
%_includedir/boost/preprocessor/*
%_includedir/boost/random/*
%_includedir/boost/test/*
%_includedir/boost/tuple/*
%_includedir/boost/type_traits/*
%_includedir/boost/utility/*
%dir %_docdir/%name-%version
%dir %_docdir/%name-%version/libs
%doc %_docdir/%name-%version/boost
%doc %_docdir/%name-%version/more
%doc %_docdir/%name-%version/people
%doc %_docdir/%name-%version/status
%doc %_docdir/%name-%version/README
%doc %_docdir/%name-%version/boost.css
%doc %_docdir/%name-%version/*.gif
%doc %_docdir/%name-%version/index.htm
%doc %_docdir/%name-%version/libs/[abcdfghilmnu]*
%doc %_docdir/%name-%version/libs/pool
%doc %_docdir/%name-%version/libs/preprocessor
%doc %_docdir/%name-%version/libs/property_map
%doc %_docdir/%name-%version/libs/random
%doc %_docdir/%name-%version/libs/rational
%doc %_docdir/%name-%version/libs/smart_ptr
%doc %_docdir/%name-%version/libs/static_assert
%doc %_docdir/%name-%version/libs/test
%doc %_docdir/%name-%version/libs/timer
%doc %_docdir/%name-%version/libs/tokenizer
%doc %_docdir/%name-%version/libs/tuple
%doc %_docdir/%name-%version/libs/type_traits


%files jam
%doc tools/build/jam_src/*.html tools/build/jam_src/INSTALL tools/build/jam_src/README 
%doc tools/build/jam_src/RELNOTES tools/build/jam_src/Porting
%_bindir/jam



%files regex
%_libdir/libboost_regex.so.*

%files regex-devel
%_bindir/boost-regex-config
%_includedir/boost/cregex.hpp
%_includedir/boost/regex.h
%_includedir/boost/regex.hpp
%_includedir/boost/regex_fwd.hpp
%dir %_includedir/boost/regex
%dir %_includedir/boost/regex/detail
%_includedir/boost/regex/*.?pp
%_includedir/boost/regex/detail/*.?pp
%_libdir/libboost_regex_debug.so*
%_libdir/libboost_regex.so
%doc %_docdir/%name-%version/libs/regex

%files regex-devel-static
%_libdir/libboost_regex_debug.a
%_libdir/libboost_regex.a



%files python
%_libdir/libboost_python*.so.*

%files python-devel
%_bindir/boost-python-config
%dir %_includedir/boost/python
%_includedir/boost/python/*
%_libdir/libboost_python*.so
%doc %_docdir/%name-%version/libs/python

%files python-devel-static
#%_libdir/libboost_python*.a




%files thread
%_libdir/libboost_thread*.so.*

%files thread-devel
%_bindir/boost-thread-config
%dir %_includedir/boost/thread
%_includedir/boost/thread/*
%_libdir/libboost_thread*.so
%doc %_docdir/%name-%version/libs/thread

%files thread-devel-static
%_libdir/libboost_thread*.a


%files signals
%_libdir/libboost_signals*.so.*

%files signals-devel
%_bindir/boost-signals-config
%dir %_includedir/boost/signals
%_includedir/boost/signals/*
%_libdir/libboost_signals*.so
%doc %_docdir/%name-%version/libs/signals

%files signals-devel-static
%_libdir/libboost_signals*.a

%post regex -p /sbin/ldconfig
%postun regex -p /sbin/ldconfig

%post python -p /sbin/ldconfig
%postun python -p /sbin/ldconfig

%post thread -p /sbin/ldconfig
%postun thread -p /sbin/ldconfig

%post signals -p /sbin/ldconfig
%postun signals -p /sbin/ldconfig

%changelog
* Tue Jan 21 2003 Alexey Voinov <voins@voins.program.ru> 1.29.0-alt1
- new version (1.29.0) now we know about g++-3.2
- fixes bug #0001863
- docs added
- new subpackage -signals- added
- boost-threads-devel-static temporarily removed, because static
  libraries for it is not built with boost build system.

* Tue Sep 10 2002 Alexey Voinov <voins@voins.program.ru> 1.28.0-alt0.4
- fixed version numbere for gcc-3.2. 
(this is temporary release)

* Mon Aug 19 2002 Alexey Voinov <voins@voins.program.ru> 1.28.0-alt0.3
- ...-config scripts renamed (s/_/-/g)
- added macros to control compilers version for which to build library

* Sun Aug 18 2002 Alexey Voinov <voins@voins.program.ru> 1.28.0-alt0.2
- spec rewrite: subpackages rearranged, files rearranged
- use gcc-version specific directories instead of update-alternatives
- remake patch updated (soname added)
- pytmake patch updated (soname fixed)
- buildreqs fixed

* Mon Jun 10 2002 Alexey Voinov <voins@voins.program.ru> 1.28.0-alt0.1
- new version (1.28.0)
- .makefile patch split into .remake and .pytmake patches
- buildreqs fixed

* Thu Jun 06 2002 Alexey Voinov <voins@voins.program.ru> 1.27.0-alt0.2
- gcc2/gcc3 variants added for regex subpackages
- /usr/bin/*_config files added
- python subpackages added
- buildreqs fixed

